import { Form } from '../../e2elib/lib/src/pageobjects/form.component';
import { ListRow } from '../../e2elib/lib/src/pageobjects/list/listrow.component';
import { ListBase } from '../../libappbase/listbase';

export class FormOperationAccount extends Form {
  public listOperationAccount = new ListOperationAccount();

  public constructor() {
    super('FormOperationAccounts');
  }
}

export class ListOperationAccount extends ListBase {
  public constructor() {
    super('ListAccounts');
  }

  public async selectOperationAccountRowByName(accName: string): Promise<void> {
    const row = await this.getOperationAccountByName(accName);
    await row.leftClick();
  }

  /**
   * Get the number of operation account in the list
   */
  public async getOperationAccountCount(): Promise<number> {
    return this.getRowCount();
  }

  /**
   * Find operation account in the list by name
   *
   * @param name Name of the unit account
   */
  public async getOperationAccountByName(name: string): Promise<ListRow> {
    return this.getRowByValue([{ columnID: ListOperationAccountColumn.Account, value: name }]);
  }
}
export enum ListOperationAccountColumn {
  Account = 'Account',
  DefaultValue = 'Default value',
  DefaultUoM = 'Default UoM',
}
